Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package backend
  Definition Classes
    nsc
-  package jvm
  Definition Classes
    backend
-  package opt
  Definition Classes
    jvm
- BoxUnbox
- ByteCodeRepository
- BytecodeUtils
- CallGraph
- ClosureOptimizer
- CopyProp
- InlineInfoAttribute
- InlineInfoAttributePrototype
- Inliner
- InlinerHeuristics
- LabelNotLive
- LocalOpt
- LocalOptImpls
- LruMap
- RemovePair
- RemovePairDependency

c

scala.tools.nsc.backend.jvm.opt

# InlineInfoAttribute

###
Companion object InlineInfoAttribute

#### case class InlineInfoAttribute(inlineInfo: InlineInfo) extends Attribute with Product with Serializable

This attribute stores the InlineInfo for a ClassBType as an independent classfile attribute. The compiler does so for every class being compiled.

The reason is that a precise InlineInfo can only be obtained if the symbol for a class is available. For example, we need to know if a method is final in Scala's terms, or if it has the @inline annotation. Looking up a class symbol for a given class filename is brittle (name-mangling).

The attribute is also helpful for inlining mixin methods. The mixin phase only adds mixin method symbols to classes that are being compiled. For all other class symbols, there are no mixin members. However, the inliner requires an InlineInfo for inlining mixin members. That problem is solved by reading the InlineInfo from this attribute.

In principle we could encode the InlineInfo into a Java annotation (instead of a classfile attribute). However, an attribute allows us to save many bits. In particular, note that the strings in an InlineInfo are serialized as references to constants in the constant pool, and those strings (method names, method signatures) would exist in there anyway. So the ScalaInlineAttribute remains relatively compact.

Source
  InlineInfoAttribute.scala

Linear Supertypes
java.io.Serializable, Product, Equals, Attribute, AnyRef, Any
Known Subclasses
InlineInfoAttributePrototype
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. InlineInfoAttribute
2. Serializable
3. Product
4. Equals
5. Attribute
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new InlineInfoAttribute(inlineInfo: InlineInfo)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from InlineInfoAttribute toany2stringadd[InlineInfoAttribute] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (InlineInfoAttribute, B)
   Implicit
     This member is added by an implicit conversion from InlineInfoAttribute toArrowAssoc[InlineInfoAttribute] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
8.  def ensuring(cond: (InlineInfoAttribute) => Boolean, msg: => Any): InlineInfoAttribute
   Implicit
     This member is added by an implicit conversion from InlineInfoAttribute toEnsuring[InlineInfoAttribute] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
9.  def ensuring(cond: (InlineInfoAttribute) => Boolean): InlineInfoAttribute
   Implicit
     This member is added by an implicit conversion from InlineInfoAttribute toEnsuring[InlineInfoAttribute] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: Boolean, msg: => Any): InlineInfoAttribute
    Implicit
      This member is added by an implicit conversion from InlineInfoAttribute toEnsuring[InlineInfoAttribute] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean): InlineInfoAttribute
    Implicit
      This member is added by an implicit conversion from InlineInfoAttribute toEnsuring[InlineInfoAttribute] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
14.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from InlineInfoAttribute toStringFormat[InlineInfoAttribute] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
15.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
16.  def getLabels(): Array[Label]
    Attributes
      protected[scala.tools.asm]
    Definition Classes
      Attribute
17.  val inlineInfo: InlineInfo
18.  def isCodeAttribute(): Boolean
    Definition Classes
      Attribute
19.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
20.  def isUnknown(): Boolean

    Not sure what this method is good for, it is not invoked anywhere in the ASM framework.

    Not sure what this method is good for, it is not invoked anywhere in the ASM framework. However, the example in the ASM manual also overrides it to `false` for custom attributes, so it might be a good idea.

    Definition Classes
      InlineInfoAttribute → Attribute
21.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
22.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
23.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
24.  def productElementNames: Iterator[String]
    Definition Classes
      Product
25.  def read(cr: ClassReader, off: Int, len: Int, buf: Array[Char], codeOff: Int, labels: Array[Label]): InlineInfoAttribute

    Deserialize the attribute into an InlineInfo.

    Deserialize the attribute into an InlineInfo. The attribute starts at cr.b(off), but we don't need to access that array directly, we can use the `read` methods provided by the ClassReader.

    `buf` is a pre-allocated character array that is guaranteed to be long enough to hold any string of the constant pool. So we can use it to invoke `cr.readUTF8`.

    Definition Classes
      InlineInfoAttribute → Attribute
26.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
27.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
28.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
29.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
30.  def write(cw: ClassWriter, code: Array[Byte], len: Int, maxStack: Int, maxLocals: Int): ByteVector

    Serialize the `inlineInfo` into a byte array.

    Serialize the `inlineInfo` into a byte array. Strings are added to the constant pool and serialized as references.

    Definition Classes
      InlineInfoAttribute → Attribute

### Deprecated Value Members

1.  def →[B](y: B): (InlineInfoAttribute, B)
   Implicit
     This member is added by an implicit conversion from InlineInfoAttribute toArrowAssoc[InlineInfoAttribute] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from Attribute

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromInlineInfoAttribute to any2stringadd[InlineInfoAttribute]

### Inherited by implicit conversion StringFormat fromInlineInfoAttribute to StringFormat[InlineInfoAttribute]

### Inherited by implicit conversion Ensuring fromInlineInfoAttribute to Ensuring[InlineInfoAttribute]

### Inherited by implicit conversion ArrowAssoc fromInlineInfoAttribute to ArrowAssoc[InlineInfoAttribute]

### Ungrouped